// qjv(PC88) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x100*16*80];
unsigned char dir[0x100];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	int trk;
	int sec;
	int size;
};

int main(int argc, char *argv[])
{
	char fname[FILENAME_MAX];
	int i,d, C, H, R, secnum;
	unsigned char id1[]="TRK   0:SCT   7L";

	if (argc != 2)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (d=0; d<numdisk; d++)
	{
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x10);
		// fBXN
		disk.ReadDATA(0x00, 0x00, 0x00, 0x07, 0x01, buff, 0x100);
		if (!memcmp(buff, id1, sizeof(id1)-1)) {
			printf("DISK AF܂.\n");
			fcut("PROG",   0x02, 0x01, 0x00, 0x01, 0x01, 0x0000, 0x7000);
			fcut("VOICE1", 0x0b, 0x05, 0x01, 0x09, 0x01, 0x0000, 0x0200);
			fcut("VOICE2", 0x0b, 0x05, 0x01, 0x0b, 0x01, 0x0000, 0x0100);

			// ȃf[^e[u̓ǂݍ
			int musnum=0;
			disk.ReadDATA1(0x01, 0x00, 0x01, 0xf7, 0x01, dir, sizeof(dir));
			// ȃf[^̐؂o
			for (i=0; i<0x11; i++) {
				if (i==5) continue;		// 4Ԃ߂Ɠd
				C = dir[i*4+1];
				H = dir[i*4+2]>>4;
				R = dir[i*4+2]&0x0f;
				secnum = dir[i*4+3]&0x0f;
				sprintf(fname,"MUS%02d",musnum++);
				printf("C:%02x H:%02x R:%02x (%04x)  ", C, H, R, secnum*0x100);
				fcut(fname, C*2+H, C, H, R, 0x01, 0x0000, secnum*0x100);
			}
		}
	}
	return 0;
}

